# TODO
# - drop dependency on libatomic from archs that don't require it
#   https://github.com/microsoft/mimalloc/issues/634
#
# Conditional build:
%bcond_without	static_libs	# static library

Summary:	Compact general purpose allocator with excellent performance
Summary(pl.UTF-8):	Mały alokator pamięci ogólnego przeznaczenia, o dobrej wydajności
Name:		mimalloc
Version:	2.2.3
Release:	1
License:	MIT
Group:		Libraries
Source0:	https://github.com/microsoft/mimalloc/archive/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	63ea5d19341717593a45e7a01138b82e
Patch0:		%{name}-build_type.patch
URL:		https://github.com/microsoft/mimalloc
BuildRequires:	cmake >= 3.18
BuildRequires:	libatomic-devel
BuildRequires:	libstdc++-devel >= 6:7
BuildRequires:	rpmbuild(macros) >= 2.047
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
mimalloc (pronounced "me-malloc") is a general purpose allocator with
excellent performance characteristics. Initially developed by Daan
Leijen for the run-time systems of the Koka and Lean languages.
Notable aspects of the design include:
- small and consistent
- free list sharding
- free list multi-sharding
- eager page reset: when a "page" becomes empty (with increased chance
  due to free list sharding) the memory is marked to the OS as unused
  ("reset" or "purged") reducing (real) memory pressure and
  fragmentation, especially in long running programs.
- secure: mimalloc can be built in secure mode
- first-class heaps
- bounded
- fast

%description -l pl.UTF-8
mimalloc (wymawiane jak "me-malloc") to alokator pamięci ogólnego
przeznaczenia, o dobrej charakterystyce wydajności. Pierwotnie został
napisany przez Daana Leijena dla systemów uruchomieniowych języków
Koka i Lean. Główne aspekty projektu to:
- mały rozmiar i spójność
- rozdrobnienie list wolnego miejsca
- wielokrotne rozdrobnienie list wolnego miejsca
- oznaczanie wolnych stron jako nie używanych
- bezpieczeństwo (można zbudować w trybie zorientowanym na
  bezpieczeństwo)
- sterty pierwszego poziomu
- ograniczenie najgorszych przypadków
- szybkość

%package devel
Summary:	Header files for the mimalloc library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki mimalloc
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	libatomic-devel

%description devel
Header files for mimalloc library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki mimalloc.

%package static
Summary:	Static mimalloc library
Summary(pl.UTF-8):	Statyczna biblioteka mimalloc
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static mimalloc library.

%description static -l pl.UTF-8
Statyczna biblioteka mimalloc.

%prep
%setup -q
%patch -P0 -p1

%build
%cmake -B build \
	-DMI_BUILD_OBJECT:BOOL=OFF \
	-DMI_BUILD_STATIC:BOOL=%{__ON_OFF static_libs} \
	-DMI_INSTALL_TOPLEVEL:BOOL=ON \
	-DMI_OPT_ARCH:BOOL=OFF

%{__make} -C build

%install
rm -rf $RPM_BUILD_ROOT

%{__make} -C build install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libmimalloc.so.*.*
%attr(755,root,root) %ghost %{_libdir}/libmimalloc.so.2

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libmimalloc.so
%{_includedir}/mimalloc.h
%{_includedir}/mimalloc-new-delete.h
%{_includedir}/mimalloc-override.h
%{_includedir}/mimalloc-stats.h
%{_libdir}/cmake/mimalloc
%{_pkgconfigdir}/mimalloc.pc

%if %{with static_libs}
%files static
%defattr(644,root,root,755)
%{_libdir}/libmimalloc.a
%endif
%changelog
* Sun Apr 27 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/mimalloc.git;a=log;h=master

* Sun Apr 27 2025 Jakub Bogusz <qboosh@pld-linux.org> 8eebe43
- updated to 2.2.3

* Mon Mar 03 2025 Jan Palus <atler@pld-linux.org> c7bbc28
- fix pl description

* Mon Mar 03 2025 Jan Palus <atler@pld-linux.org> c09fde7
- up to 2.1.9

* Mon Mar 03 2025 Jan Palus <atler@pld-linux.org> c26c5d8
- use %patch -P

* Sun Nov 17 2024 Jakub Bogusz <qboosh@pld-linux.org> 90fede6
- less detailed description, pl

* Sun Jun 09 2024 Jan Palus <atler@pld-linux.org> a47e6a6
- up to 2.1.7

* Fri May 03 2024 Jan Palus <atler@pld-linux.org> da26cf7
- add static_libs bcond

* Fri May 03 2024 Jan Palus <atler@pld-linux.org> 11aa12b
- up to 2.1.4

* Thu May 04 2023 Jan Palus <atler@pld-linux.org> 5d53036
- up to 2.1.2

* Thu May 04 2023 Jan Palus <atler@pld-linux.org> 6b96290
- BR: libstdc++-devel

* Fri Apr 07 2023 Jan Palus <atler@pld-linux.org> 1eda7e2
- up to 2.1.1

* Mon Dec 26 2022 Jan Palus <atler@pld-linux.org> 6be20ae
- up to 2.0.9

* Sun Nov 13 2022 Jan Palus <atler@pld-linux.org> 6e447d2
- up to 2.0.7

* Wed Oct 19 2022 Jan Palus <atler@pld-linux.org> 159c8df
- unconditionally require libatomic-devel for consistent dependencies; rel 3

* Thu Sep 29 2022 Jan Palus <atler@pld-linux.org> 0f6d005
- rebuild without cmake completness check

* Mon Apr 18 2022 Jan Palus <atler@pld-linux.org> d1e4dc2
- BR: libatomic-devel on %{armv6}

* Mon Apr 18 2022 Jan Palus <atler@pld-linux.org> 5dfbf05
- up to 2.0.6

* Sat Mar 05 2022 Jan Palus <atler@pld-linux.org> 53198f5
- up to 2.0.5 (new soname)

* Wed Dec 15 2021 Jan Palus <atler@pld-linux.org> d65d308
- new

